unit Noty_f;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Nastsoubor1: TMenuItem;
    Konec1: TMenuItem;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    Noty: TMemo;
    Delky_not: TMemo;
    Image1: TImage;
    Klic: TImage;
    Znak_taktu: TImage;
    procedure Konec1Click(Sender: TObject);
    procedure Nastsoubor1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Vykresli_osnovu;
    procedure Vykreslitosnovu1Click(Sender: TObject);
    procedure Vykreslovani_not;
    procedure Vykreslitnoty1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  cesta_pisne:string;
  zapisy:array of string;
  delky:array of integer;
  noty_image:array of timage;
  delka_skladby:integer;
  typ_taktu:integer;

implementation

{$R *.dfm}

procedure TForm1.Konec1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Nastsoubor1Click(Sender: TObject);
var i:integer;
    delka_noty:string;
begin
  i:=0;
  delka_noty:='';

  if OpenDialog1.Execute=true then
   cesta_pisne:=OpenDialog1.FileName;

  memo1.Lines.LoadFromFile(cesta_pisne);
  delka_skladby:=Memo1.Lines.Count;

  SetLength(zapisy,delka_skladby);
  SetLength(delky,delka_skladby);
  SetLength(noty_image,delka_skladby);

  case ((Memo1.Lines.Strings[0])[1]) of
  '3':begin typ_taktu:=3; Znak_taktu.Picture.LoadFromFile('znaky/takt_3.bmp'); end;
  '4':begin typ_taktu:=4; Znak_taktu.Picture.LoadFromFile('znaky/takt_4.bmp');end;
  '5':begin typ_taktu:=5; Znak_taktu.Picture.LoadFromFile('znaky/takt_5.bmp');end;
  end;

repeat
  i:=i+1;
  if ((memo1.Lines.Strings[i])[1])<>'p'
   then
     begin
       zapisy[i]:=((memo1.Lines.Strings[i])[1]);
       if ((memo1.Lines.Strings[i])[4])='.'
        then if ((memo1.Lines.Strings[i])[3])='0'
               then
                 delky[i]:=8
               else
                 delky[i]:=9
        else
          delky[i]:=strtoint(((memo1.Lines.Strings[i])[3]));
     end
   else
     begin
       zapisy[i]:='p';
       if ((memo1.Lines.Strings[i])[9])='.'
        then if ((memo1.Lines.Strings[i])[8])='0'
              then
                delky[i]:=8
              else
                delky[i]:=9
        else
          delky[i]:=strtoint(((memo1.Lines.Strings[i])[8]));
     end
until i=delka_skladby-1;

  for i:=1 to delka_skladby-1 do
    begin
      Noty.Lines.Add(zapisy[i]);
      Delky_not.Lines.add(floattostr(delky[i]));
    end;
Vykresli_osnovu;
Vykreslovani_not;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.FillRect(Image1.Canvas.ClipRect);
  Vykresli_osnovu;
end;

procedure TForm1.Vykresli_osnovu;
var i,q:integer;
const vzdalenost_radek=10;
begin
  q:=0;
  for i:=1 to 5 do
    begin
      image1.Canvas.MoveTo(10,vzdalenost_radek*i+q+10);
      image1.Canvas.LineTo(image1.Width-10,vzdalenost_radek*i+q+10);
      if (i=3) then
        begin
          q:=1;
          image1.Canvas.MoveTo(10,(vzdalenost_radek*i)+q+10);
          image1.Canvas.LineTo(Image1.Width-10,(vzdalenost_radek*i)+q+10);
        end;
    end;

//!! Oddlen kle a znaky taktu
{  image1.Canvas.MoveTo(50,20);
  image1.Canvas.LineTo(50,100);
  image1.Canvas.MoveTo(80,20);
  Image1.Canvas.LineTo(80,100);
for i:=1 to 30 do begin
  image1.Canvas.MoveTo(100+(i*20),20);
  image1.Canvas.LineTo(100+(i*20),100);
end;}
end;

procedure TForm1.Vykreslitosnovu1Click(Sender: TObject);
begin
  Vykresli_osnovu;
end;

procedure TForm1.Vykreslovani_not;
var typ_nohy_noty:char;
    i:integer;
const q=50;
begin
i:=0;
repeat
  i:=i+1;
  if ((zapisy[i]='C')
   or (zapisy[i]='D')
    or (zapisy[i]='E')
     or (zapisy[i]='F')
      or (zapisy[i]='G')
       or (zapisy[i]='A')
        or (zapisy[i]='H')
         or (zapisy[i]='Cis')
          or (zapisy[i]='Dis')
           or (zapisy[i]='Fis')
            or (zapisy[i]='Gis')
             or (zapisy[i]='Ais'))
  then typ_nohy_noty:='n'
  else typ_nohy_noty:='d';

//vytven not
  noty_image[i]:=TImage.Create(GroupBox1);
  noty_image[i].Parent:=Form1;
  noty_image[i].Left:=160+(i*32);

//obrazek noty
  if (zapisy[i]='C')
   or (zapisy[i]='D')
    or (zapisy[i]='E')
     or (zapisy[i]='F')
      or (zapisy[i]='G')
       or (zapisy[i]='A')
        or (zapisy[i]='H') then case delky[i] of
           8 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_nahoru_0.bmp');
           1 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_nahoru_1.bmp');
           9 : begin try
                 noty_image[i].Picture.LoadFromFile('Znaky/Nota_nahoru_1.bmp');
                 Image1.Canvas.Pixels[(noty_image[i].Left+35),(noty_image[i].Top+q)]:=clblack;
                 Image1.Canvas.Pixels[(noty_image[i].Left+34),(noty_image[i].Top+q)]:=clblack;
                 Image1.Canvas.Pixels[(noty_image[i].Left+35),(noty_image[i].Top+q+1)]:=clblack;
                 Image1.Canvas.Pixels[(noty_image[i].Left+34),(noty_image[i].Top+q+1)]:=clblack;
                 except end;
               end;
           2 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_nahoru_2.bmp');
           3 : begin try
                 noty_image[i].Picture.LoadFromFile('Znaky/Nota_nahoru_2.bmp');
                 Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q)]:=clblack;
                 Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q)]:=clblack;
                 Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1)]:=clblack;
                 Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1)]:=clblack;
                 except end;
               end;
           4 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_4.bmp');
         end;

  if (zapisy[i]='Cis')
   or (zapisy[i]='Dis')
    or (zapisy[i]='Fis')
     or (zapisy[i]='Gis')
      or (zapisy[i]='Ais') then case delky[i] of
        8 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_nahoru_0.bmp');
        1 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_nahoru_1.bmp');
        9 : begin try
              noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_nahoru_1.bmp');
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1)]:=clblack;
              except end;
            end;
        2 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_nahoru_2.bmp');
        3 : begin try
              noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_nahoru_2.bmp');
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1)]:=clblack;
              except end;
            end;
        4 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_4.bmp');
      end;

  if (zapisy[i]='c')
   or (zapisy[i]='d')
    or (zapisy[i]='e')
     or (zapisy[i]='f')
      or (zapisy[i]='g')
       or (zapisy[i]='a')
        or (zapisy[i]='h') then case delky[i] of
        8 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_dolu_0.bmp');
        1 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_dolu_1.bmp');
        9 : begin try
              noty_image[i].Picture.LoadFromFile('Znaky/Nota_dolu_1.bmp');
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q-30)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q-30)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1-30)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1-30)]:=clblack;
              except end;
            end;
        2 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_dolu_2.bmp');
        3 : begin try
              noty_image[i].Picture.LoadFromFile('Znaky/Nota_dolu_2.bmp');
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1)]:=clblack;
              except end;
            end;
        4 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_4.bmp');
      end;

  if (zapisy[i]='cis')
   or (zapisy[i]='dis')
    or (zapisy[i]='fis')
     or (zapisy[i]='gis')
      or (zapisy[i]='ais') then case delky[i] of
        8 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_dolu_0.bmp');
        1 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_dolu_1.bmp');
        9 : begin try
              noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_dolu_0.bmp');
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1)]:=clblack;
              except end;
            end;
        2 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_dolu_2.bmp');
        3 : begin try
              noty_image[i].Picture.LoadFromFile('Znaky/Nota_krizek_dolu_2.bmp');
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-130),(noty_image[i].Top+q+1)]:=clblack;
              Image1.Canvas.Pixels[(noty_image[i].Left-129),(noty_image[i].Top+q+1)]:=clblack;
              except end;
            end;
        4 : noty_image[i].Picture.LoadFromFile('Znaky/Nota_4.bmp');
      end;

  if zapisy[i]='p' then case delky[i] of
    8 : noty_image[i].Picture.LoadFromFile('Znaky/Pomlka_0.bmp');
    1 : noty_image[i].Picture.LoadFromFile('Znaky/Pomlka_1.bmp');
    9 : begin try
          noty_image[i].Picture.LoadFromFile('Znaky/Pomlka_1.bmp');
          Image1.Canvas.Pixels[(noty_image[i].Left-127),(noty_image[i].Top+q-13)]:=clblack;
          Image1.Canvas.Pixels[(noty_image[i].Left-126),(noty_image[i].Top+q-13)]:=clblack;
          Image1.Canvas.Pixels[(noty_image[i].Left-127),(noty_image[i].Top+q+1-13)]:=clblack;
          Image1.Canvas.Pixels[(noty_image[i].Left-126),(noty_image[i].Top+q+1-13)]:=clblack;
          except end;
        end;
    2 : noty_image[i].Picture.LoadFromFile('Znaky/Pomlka_2.bmp');
    3 : begin try
          noty_image[i].Picture.LoadFromFile('Znaky/Pomlka_2.bmp');
          Image1.Canvas.Pixels[(noty_image[i].Left-127),(noty_image[i].Top+q-13)]:=clblack;
          Image1.Canvas.Pixels[(noty_image[i].Left-126),(noty_image[i].Top+q-13)]:=clblack;
          Image1.Canvas.Pixels[(noty_image[i].Left-127),(noty_image[i].Top+q+1-13)]:=clblack;
          Image1.Canvas.Pixels[(noty_image[i].Left-126),(noty_image[i].Top+q+1-13)]:=clblack;
          except end;
        end;
    4 : noty_image[i].Picture.LoadFromFile('Znaky/Pomlka_4.bmp');
  end;

//Vyska noty
  if (zapisy[i]='C')or(zapisy[i]='Cis') then noty_image[i].Top:=50;
  if (zapisy[i]='D')or(zapisy[i]='Dis') then noty_image[i].Top:=40;
  if (zapisy[i]='E') then noty_image[i].Top:=35;
  if (zapisy[i]='F')or(zapisy[i]='Fis') then noty_image[i].Top:=30;
  if (zapisy[i]='G')or(zapisy[i]='Gis') then noty_image[i].Top:=25;
  if (zapisy[i]='A')or(zapisy[i]='Ais') then noty_image[i].Top:=20;
  if (zapisy[i]='H') then noty_image[i].Top:=15;
  if (zapisy[i]='c')or(zapisy[i]='cis') then noty_image[i].Top:=32;
  if (zapisy[i]='d')or(zapisy[i]='dis') then noty_image[i].Top:=27;
  if (zapisy[i]='e') then noty_image[i].Top:=22;
  if (zapisy[i]='f')or(zapisy[i]='fis') then noty_image[i].Top:=17;
  if (zapisy[i]='g')or(zapisy[i]='gis') then noty_image[i].Top:=12;
  if (zapisy[i]='a')or(zapisy[i]='ais') then noty_image[i].Top:=5;
  if (zapisy[i]='h') then noty_image[i].Top:=2;

  if (zapisy[i]='p')and(delky[i]=8) then noty_image[i].Top:=35;
  if (zapisy[i]='p')and((delky[i]=1)or(delky[i]=9)) then noty_image[i].Top:=30;
  if (zapisy[i]='p')and((delky[i]=2)or(delky[i]=3)) then noty_image[i].Top:=39;
  if (zapisy[i]='p')and(delky[i]=4) then noty_image[i].Top:=33;


until i=delka_skladby-1;
Vykresli_osnovu;
end;

procedure TForm1.Vykreslitnoty1Click(Sender: TObject);
begin
  Vykreslovani_not;
  Vykresli_osnovu;
end;

end.
